package br.com.smooph.launcher;


import java.awt.Color;
import java.awt.Desktop;
import java.awt.Font;
import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;

import javax.swing.JEditorPane;
import javax.swing.JLabel;
import javax.swing.event.HyperlinkEvent;
import javax.swing.event.HyperlinkListener;


public class MessageWithLink extends JEditorPane
{
	
	
	private static final long serialVersionUID = 1L;
	
	public MessageWithLink(String htmlBody)
	{
		super("text/html", "<html><body style=\"" + getStyle() + "\">" + htmlBody + "</body></html>");
		addHyperlinkListener(new HyperlinkListener()
		{
			
			
			public void hyperlinkUpdate(HyperlinkEvent e)
			{
				if(e.getEventType().equals(HyperlinkEvent.EventType.ACTIVATED))
				{
					if(Desktop.isDesktopSupported())
					{
						try
						{
							Desktop.getDesktop().browse(new URI(e.getURL() + ""));
							return;
						}
						catch(IOException e1)
						{
							e1.printStackTrace();
							return;
						}
						catch(URISyntaxException e1)
						{
							e1.printStackTrace();
						}
					}
				}
			}
		});
		setEditable(false);
		setBorder(null);
	}
	
	static StringBuffer getStyle()
	{
		JLabel label = new JLabel();
		Font font = label.getFont();
		Color color = label.getBackground();
		
		StringBuffer style = new StringBuffer("font-family:" + font.getFamily() + ";");
		style.append("font-weight:" + (font.isBold() ? "bold" : "normal") + ";");
		style.append("font-size:" + font.getSize() + "pt;");
		style.append("background-color: rgb(" + color.getRed() + "," + color.getGreen() + "," + color.getBlue() + ");");
		return style;
	}
}