package br.com.smooph.launcher;


import java.awt.Color;
import java.awt.Component;
import java.awt.Image;
import java.awt.Toolkit;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import javax.imageio.ImageIO;
import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

import org.json.simple.JSONObject;
import org.json.simple.parser.JSONParser;
import org.json.simple.parser.ParseException;


public class Window extends JFrame
{
	
	
	private static final long serialVersionUID = 1L;
	private int width = 870;
	private int height = 475;
	private static List<Component> components = new ArrayList<Component>();
	
	public Window()
	{
		this.getContentPane().setLayout(null);
		this.setDefaultCloseOperation(3);
		this.setIconImage(Toolkit.getDefaultToolkit().getImage(this.getClass().getResource("/br/com/smooph/launcher/resources/icon.png")));
		this.setResizable(false);
		this.setTitle("CraftLandia");
		this.setSize(this.width, this.height);
		this.setLocationRelativeTo(null);
		
		JLabel banner = null;
		try
		{
			Image image = ImageIO.read(this.getClass().getResource("/br/com/smooph/launcher/resources/banner.png"));
			if(image != null)
			{
				banner = new JLabel(new ImageIcon(image));
				banner.setBounds(6, 5, 853, 270);
				this.getContentPane().add(banner);
			}
		}
		catch(IOException v0)
		{
			v0.printStackTrace();
		}
		
		JPanel menu = new JPanel();
		menu.setBounds(5, 280, 855, 130);
		menu.setLayout(null);
		this.getContentPane().add(menu);
		
		JButton jButton1 = new JButton("JOGAR MINIGAMES");
		jButton1.setBounds(0, 0, 425, 40);
		jButton1.setVisible(true);
		menu.add(jButton1);
		
		JButton jButton11 = new JButton("JOGAR ECLIPSE 1.7 RPG");
		jButton11.setBounds(430, 0, 425, 40);
		jButton11.setVisible(true);
		menu.add(jButton11);
		
		JButton jButton2 = new JButton("JOGAR SURVIVAL 1.8");
		jButton2.setBounds(0, 45, 282, 40);
		jButton2.setVisible(true);
		menu.add(jButton2);
		
		JButton jButton3 = new JButton("JOGAR SURVIVAL 1.7.2");
		jButton3.setBounds(287, 45, 282, 40);
		jButton3.setVisible(true);
		menu.add(jButton3);
		
		JButton jButton4 = new JButton("JOGAR SURVIVAL PREMIUM 1.7.2");
		jButton4.setBounds(287, 90, 281, 40);
		jButton4.setVisible(true);
		menu.add(jButton4);
		
		JButton jButton5 = new JButton("---");
		jButton5.setBounds(0, 90, 282, 40);
		jButton5.setEnabled(false);
		jButton5.setVisible(true);
		menu.add(jButton5);
		
		JButton jButton6 = new JButton("JOGAR SURVIVAL 1.5.2");
		jButton6.setBounds(574, 45, 281, 40);
		jButton6.setVisible(true);
		menu.add(jButton6);
		
		JButton jButton7 = new JButton("JOGAR SURVIVAL 1.5.2 (Titans)");
		jButton7.setBounds(574, 90, 281, 40);
		jButton7.setVisible(true);
		menu.add(jButton7);
		
		JPanel info = new JPanel();
		info.setBorder(BorderFactory.createLineBorder(Color.BLACK));
		info.setBounds(6, menu.getY() + 136, 853, 25);
		
		JLabel jLabel2 = new JLabel("");
		info.add(jLabel2);
		this.add(info);
		
		banner.addMouseListener(new InfoListener());
		
		jButton1.addActionListener(new ButtonActionListener(Version.v172_C));
		jButton1.addMouseListener(new ButtonMouseListener(jLabel2, "O servidor de minigames é um servidor com vários jogos para se divertir em grupo, neste servidor, todos podem ter SKIN!"));
		
		jButton11.addActionListener(new ButtonActionListener(Version.v172));
		jButton11.addMouseListener(new ButtonMouseListener(jLabel2, "O servidor Eclipse é um servidor de RPG na versão 1.7.x do jogo.!"));
		
		jButton2.addActionListener(new ButtonActionListener(Version.v180));
		jButton2.addMouseListener(new ButtonMouseListener(jLabel2, "Servidores no estilo tradicional do Minecraft (sobrevivência) na versão 1.8.x do jogo."));
		
		jButton3.addActionListener(new ButtonActionListener(Version.v172));
		jButton3.addMouseListener(new ButtonMouseListener(jLabel2, "Servidores no estilo tradicional do Minecraft (sobrevivência) na versão 1.7.x do jogo."));
		
		jButton4.addActionListener(new ButtonActionListener(Version.v172_P));
		jButton4.addMouseListener(new ButtonMouseListener(jLabel2, "Servidores no estilo tradicional do Minecraft (sobrevivência) na versão 1.7.x do jogo. (Apenas para quem tem o jogo original)"));
		
		jButton5.addMouseListener(new ButtonMouseListener(jLabel2, "Esse botão será usado no futuro, quando lançarmos um novo servidor!"));
		
		jButton6.addActionListener(new ButtonActionListener(Version.v152));
		jButton6.addMouseListener(new ButtonMouseListener(jLabel2, "Servidores no estilo tradicional do Minecraft (sobrevivência) na versão 1.5.x do jogo."));
		
		jButton7.addActionListener(new ButtonActionListener(Version.v152_C));
		jButton7.addMouseListener(new ButtonMouseListener(jLabel2, "Servidores no estilo tradicional do Minecraft (sobrevivência) na versão 1.5.x do jogo, nestes servidores, todos podem ter SKIN!"));
		
		this.setVisible(true);
		
		components = Arrays.asList(getContentPane().getComponents());
	}
	
	private static List<Component> getComponentsPane()
	{
		return components;
	}
	
	public static void disableButtons()
	{
		for(Component component : Window.getComponentsPane())
		{
			if(component instanceof JButton)
			{
				component.setEnabled(false);
			}
			
			if(component instanceof JPanel)
			{
				JPanel jPanel = (JPanel) component;
				
				for(Component component2 : jPanel.getComponents())
				{
					if(component2 instanceof JButton)
					{
						component2.setEnabled(false);
					}
				}
			}
		}
	}
	
	@SuppressWarnings("unchecked")
	public static void veriryFiles(Version version)
	{
		try
		{
			File launcher_profiles = new File(version.getDirName() + "/data/.minecraft/launcher_profiles.json");
			File options = new File(version.getDirName() + "/data/.minecraft/options.txt");
			File launcher = new File(version.getDirName() + "/data/launcher.jar");
			File servers = new File(version.getDirName() + "/data/.minecraft/servers.dat");
			
			if(launcher_profiles.exists() && options.exists() && launcher.exists() && servers.exists())
			{
				JSONParser parser = new JSONParser();
				FileReader profilesReader = new FileReader(launcher_profiles);
				JSONObject jsonObject = (JSONObject) parser.parse(profilesReader);
				jsonObject.put("selectedProfile", version.getVersionName());

				FileWriter fileWriter = new FileWriter(launcher_profiles);
				fileWriter.write(jsonObject.toJSONString());
				fileWriter.close();
				Window.openLauncher(version);
				return;
			}
		}
		catch(FileNotFoundException e)
		{
			e.printStackTrace();
		}
		catch(IOException e)
		{
			e.printStackTrace();
		}
		catch(ParseException e)
		{
			e.printStackTrace();
		}

		JOptionPane.showMessageDialog(null, new MessageWithLink("Ops, houve um erro.. por favor clique <a href=\"http://forum.craftlandia.com.br/ipb/index.php?/topic/729852-launcher-universal-com-java-embutido/\">OK</a> para acessar nosso fórum de suporte."));
		return;
	}
	
	public static void openLauncher(Version version)
	{
		try
		{
			List<String> list = new ArrayList<String>();
			
			if(System.getProperty("os.name").toLowerCase().contains("win"))
			{
				list.add("javaw");
			}
			else
			{
				list.add("java");
			}
			list.add("-jar");
			list.add("launcher.jar");

			ProcessBuilder processbuilder = new ProcessBuilder(list);
			processbuilder.directory(new File(version.getDirName()));
			processbuilder.environment().put("APPDATA", "data");
			processbuilder.start();
			System.exit(0);
			return;
		}
		catch(IOException e)
		{
			e.printStackTrace();
		}

		JOptionPane.showMessageDialog(null, new MessageWithLink("Ops, houve um erro.. por favor clique <a href=\"http://forum.craftlandia.com.br/ipb/index.php?/topic/729852-launcher-universal-com-java-embutido/\">OK</a> para acessar nosso fórum de suporte."));
	}
}
