/*
 * Decompiled with CFR 0_115.
 */
package br.com.smooph.launcher.utils;


import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.nio.channels.FileChannel;
import java.nio.channels.ReadableByteChannel;


public final class Files
{
	
	public static void copy(File source, File destination) throws IOException
	{
		if(source == null)
		{
			throw new NullPointerException("Source must not be null");
		}
		
		if(destination == null)
		{
			throw new NullPointerException("Destination must not be null");
		}
		
		if(!source.exists())
		{
			throw new FileNotFoundException("Source '" + source + "' does not exist");
		}
		
		if(source.isDirectory())
		{
			throw new IOException("Source '" + source + "' exists but is a directory");
		}
		
		if(source.getCanonicalPath().equals(destination.getCanonicalPath()))
		{
			throw new IOException("Source '" + source + "' and destination '" + destination + "' are the same");
		}

		File parentDestination = destination.getParentFile();
		if(parentDestination != null && !parentDestination.mkdirs() && !parentDestination.isDirectory())
		{
			throw new IOException("Destination '" + parentDestination + "' directory cannot be created");
		}
		
		if(destination.exists() && !destination.canWrite())
		{
			throw new IOException("Destination '" + destination + "' exists but is read-only");
		}
		
		if(destination.exists() && destination.isDirectory())
		{
			throw new IOException("Destination '" + destination + "' exists but is a directory");
		}
		
		FileInputStream fileInputStream = null;
		FileOutputStream fileOutputStream = null;
		FileChannel sourceChannel = null;
		FileChannel destinationChannel = null;
		
		try
		{
			fileInputStream = new FileInputStream(source);
			fileOutputStream = new FileOutputStream(destination);
			sourceChannel = fileInputStream.getChannel();
			destinationChannel = fileOutputStream.getChannel();

			long l2;
			long l3 = sourceChannel.size();
			for(long i2 = 0; i2 < l3; i2 += destinationChannel.transferFrom((ReadableByteChannel) sourceChannel, i2, l2))
			{
				l2 = l3 - i2 > 31457280 ? 31457280 : l3 - i2;
			}
		}
		finally
		{
			fileInputStream.close();
			fileOutputStream.close();
			sourceChannel.close();
			destinationChannel.close();
		}
		
		if(source.length() != destination.length())
		{
			throw new IOException("Failed to copy full contents from '" + source + "' to '" + destination + "'");
		}
		
		destination.setLastModified(source.lastModified());
	}
}
